function out=Method_Timoshenko(profile,coeffs,E,G,rho,x_section,nu,d0,width,bar_length,number_of_elements,tol,number_fn,ploton)
global d b len;
a1=coeffs(1); a2=coeffs(2); middle_d=coeffs(3);
[b,d,len]=Shape(width,d0,bar_length,profile,a1,a2,middle_d,number_of_elements,ploton);
%check size of steps in profile
delta_d_max=0;
for k=1:length(d)-1
delta_d_max=max([delta_d_max abs((d(k)-d(k+1))/d(k))]);
end;
% Find the natural frequencies to this tolerance (rad/s)
tolerance=tol(1);
how_many=number_fn;
%place to store results by using Timoshenko
recept_all_timoshenko=[];
freq=[]; % place to store freqs
for w=logspace(2,5,600); % nice spread of frequencies
recept_timoshenko=beam_recept_timoshenko(w,E,rho,b,d,len,x_section,G,nu);
recept_all_timoshenko=[recept_all_timoshenko recept_timoshenko(1,1)];
freq=[freq w]; % record the freq in rad/s
end;
% Find the resonances - Timoshenko
bracket=bracket_natfreq(recept_all_timoshenko,freq,how_many);
if isempty(bracket)
error('No natural frequencies found. Perhaps alter frequency span?');
end;
nat_freqs=find_freq_timo(bracket,tolerance);
fundamental_Timoshenko=nat_freqs(1)./(2*pi);
ratios_Timoshenko=nat_freqs./nat_freqs(1);
if ploton
out=d;
else
out=[fundamental_Timoshenko;ratios_Timoshenko(2:how_many)];
end;