function [b,d,len]=Shape(width,d0,bar_length,profile,a1,a2,middle_d,number_of_elements,ploton)
%Generates the sizes of all of the beam elements based on the equation of the cutout.
%Shape currently a cubic (no linear term) y=a1*|x|^3 + a2*|x|^2 + a3
%to make sure the element decided to be break into are even numbers
if(mod(number_of_elements,2))~=0
	error('Choose even number for number of elements');
end;
size_of_elements=bar_length./number_of_elements;
a3=middle_d; % depth at centre of bar
%on x-axis, x varies starting from 0 to half of the bar length in an increments of the size of each element
x=0:size_of_elements:bar_length*0.5;
if a3>=d0
	error('complete sever!');
elseif a3<=0
	error('No cutout!');
end;
%Calculate the shape of the cutout.
switch profile
	case 'cubic'
	y=a1.*x.^3 + a2.*x.*x + a3;
case 'parabola'
for k=1:length(x) % flat with parabolic ends
	if x(k)<=a1;
	y(k)=a3;
	end;
	if x(k)>a1
	%parabola with origin shifted to end of parallel portion
	x_temp=x(k)-a1;
	y(k)=a2.*x_temp.*x_temp+a3;
	end;
	end;
case 'cosine'
	
case 'exp_plus'
	y=(a3./2).*(exp(a1.*x)+exp(a2.*x));
case 'exp_minus'
	y=a3.*(1+exp(a1.*x)-exp(a2.*x));
case 'prismatic'
	y=d0.*(x+1)./(x+1);
	otherwise
	error('Unknown cutout profile');
	end;
	for k=1:length(y);
	if y(k) > d0;
	y(k)=d0;
	elseif y(k) < 0;
	error('Part of beam thickness gone to zero');
	end;
end;
%to make the cutout shape more smooth, the resulted cutout values above at
%two points close together can be joined by calculating the mean value of
%those two vlaues
for k=1:number_of_elements/2
d_temp(k)=(y(k)+y(k+1))./2; % mean thickness of section
end;
d=[]; len=[]; k=0;
% Merge contiguous elements of same depth into one.
% This removes unnecessary divisions and minimises the number of elements.
while k<number_of_elements/2
k=k+1;
d=[d d_temp(k)];
len=[len size_of_elements];
%while((k<number_of_elements/2) && (d_temp(k+1)==d_temp(k)))
% len(length(len))=len(length(len))+size_of_elements;
% k=k+1;
%end;
end;
b=width*ones(1,2*length(d));
% mirror to build final vectors
d=[fliplr(d) d];
len=[fliplr(len) len];
if ploton
H1=figure(1);
subplot(2,1,1);
line(1000.*[0 -bar_length*0.5 fliplr(-x) x bar_length*0.5 0],1000.*[0 0 fliplr(y) y 0 0]);
axis equal;
xlabel('To scale');
subplot(2,1,2);
line(1000.*[0 -bar_length*0.5 fliplr(-x) x bar_length*0.5 0],1000.*[0 0 fliplr(y) y 0 0]);
xlabel('Thickness stretched');
end;